function [a,b,c,d,rcon]=abcdcoeff(A,B,C)
   //Programed by Francisco Ronay López Estrada --- 17 jaudi de marche
   // ronaystein@gmail.com  ----sites.google.com/site/ronaystein 
    // this functio find the $a,b,c,d$  coeffientes of ecuations 6.1-6.2 of
    //               $aE+bC=I$ 
    //               $cE+dC=0$
    //               
    //IEEE  TRANSACTIONS  ON AUMMATIC  CONTROL, VOL.  40, NO.  7. JULY  I995 
//Design of  Observers for Descriptor Systems 
//M.  Darouach  and  M.  Boutayeb 
// 
    
    // Find the QR r.s.e, more information review the rqrse.sci function 
  
   [Ee, Ae, Ae1, Be, Be1, Ce]=qrrse(E,A,B,C)
    
    // compute the dimentions
    m=size(A,1);
    n=size(A,2);
    p=size(C,1)
    r=rank(E);
// 2do step finding the matriz
// $svd\begin{bmatrix} E \cr C \end{bmatrix}= \begin{bmatrix} \sum  \cr 0 \end{bmatrix}$

[U,Sv,V]=svd([Ee;Ce])
S=Sv(1:size(Ee,2),:)

// Then $\begin{bmatrix} a & b \cr c & d\end{bmatrix}=\begin{bmatrix} VS^{-1} & 0 \cr 0 & I_{m+p-n}\end{bmatrix} U^T$


abcd=clean([V*inv(S) zeros(size(V,1),m+p-n);zeros(V) eye(size(V,1),m+p-n) ]*U');
    
a=abcd(1:m, 1:r)    ;

b=abcd(1:m,r+1:size(abcd,2) ) ;   
c=abcd(m+1:m+p,1:r);
d=abcd(m+1:m+p, size(c,2) + 1:size(abcd,2))

//optinally you can select the comprobation of 
// //               $aE+bC=I$ 
    //               $cE+dC=0$
   //rcon 
    rcon=clean([a*Ee+b*Ce; c*Ee+d*Ce])
                
endfunction