function [N,K,L1,L2,G,test]=darobsv95(E,A,B,C,poles)
       
// this function compute the gains of Darouach observer of 1995 [1]
//Controllability condition

[nC,Co_mat,nR,Ro_mat,nI,Io_mat]=dobsv(E,A,C);
if nI(2)~=(size(E,1)+rank(E))
    error('The system is not I-Observable')
    return;
end
    
// qr r.s.e
[Ee, Ae, Ae1, Be, Be1, Ce]=qrrse(E,A,B,C)
 
 // a,b,c,d coefficients
[a,b,c,d,rcon]=abcdcoeff(A,B,C);
// stability matrix
 N=diag(poles)
aA=a*Ae
cA=[c*Ae;Ce]
// solve the LME for $Ks=[K -L_2 ]$
// $N=aA+Ks\begin{bmatrix}cA \\ C\end{bmatrix}$

if rank([aA;cA])~=size(E,1)
   error('The pair (aA, [cA;C]) is not detectable')
   
end
[Ks]=DarouachLME(aA,cA,N);
 
 // K gain
 n1=size(d,1);
 n2=size(Ks,2);
 K=clean(Ks(:,1:n1));
 // $L_2$ gain
L2=clean(-Ks(:,n1+1:n2));
// $L_1$ gain
L1=clean(N*(b+K*d));
// $G$ gain
G=clean((a+K*c)*Be);
test=clean(aA+Ks*cA);
endfunction
