function [nC,C_mat,nR,R_mat,nI,I_mat]=dcontr (varargin)
    [lhs,rhs]=argn(0) 
      
      // This fuction compute the C-Controlability, R-Controlability and I-Controlability, according with the next methods
      // flag=0:  Direct method
      // flag=1:  Laurent expansion approach
      // flag=2:  kronecker-weistrauss canonical form
      E=varargin(1);
      A=varargin(2);
      B=varargin(3);
      
      if rhs==3 
          flag=0;
      else
          flag=varargin(4);
      end
      
      
      select flag
          case 0 then
      
      //This function chel the next condition for C-Controability
      //1.  The slow subsystem  is C-Controlable if and only if
      //$rank\begin{bmatrix}sE-A & B\end{bmatrix}=n,\,\,\,\forall s\in\mathbb{C},\,\, s\, finite$
     
   
     Cslow=[E-A B];
     nCs=rank(Cslow);
//2. The fast subsystem  is C-Controlable if and only if
        //$rank\begin{bmatrix}E &  & B\end{bmatrix}=n$

        Cfast=[E B]
        nCf=rank(Cfast)
        if  nCs==nCf then
// System  is C-controllable if and only if slow  and fast subsystems are C-Controllable
            nC=list("Rank of C-slow = C-fast matrices",nCs,"System is controllabl")
        else
            nC=list("Rank of C-slow matrix",nCs, "Rank of C-fast matrix",nCf)
            
        end
        
               
        C_mat=list('C-slow matrix',Cslow,'C-fast matrix',Cfast)
//The regular descriptor system  is R-Controlable if and only if
//$rank\begin{bmatrix}sE-A & B\end{bmatrix}=n,\,\,\,\forall s\in\mathbb{C},\,\, s\, finite$
nR=list("Rank of R-Controllability matrix",nCs);

R_mat=list("R-Controllability matrix",Cslow);
//The regular descriptor system is I-Controlable if and only if
//$rank\begin{bmatrix}E & 0 & 0\\A & E & B \end{bmatrix}=n+rank\, E$

I_mat=[E zeros(E) zeros(B); A E B]
I_mat=list("I-controllability matrix", I_mat)
nIa=rank(I_mat(2))

if nIa== size(E,1)+rank(E) then
   nI=list("System is I-Controllable (I-matrix rank)", nIa)
   
else
   nI=list("Sytem is not Controlable (I-matrix rank)", nIa)
end

//--------------------------------------------------------------------------------------------------------------------------------------------------------
case 1 then
    // Cntrd = controlability matrix , nC = rank of the  Cntrd matrix
//Rctrd  = Rcontrolability       , nR=Rank of the Rctrd matrix
// Ictrb = Impulse controlability, nI=is T if only if rank(Ictrb)=Rank(Phi(-2))
//F. N. Koumboulis and G. Mertzios. ON KALMAN'S CONTROLLABILITY ND OBSERVABILITY CRITERIA FOR    SINGULAR SYSTEMS. CIRCUITSSYSTEMSAND SIGNALPROCESSING
//VOL. 18, No. 3, 1999, PP. 269-290


Aux=size(A,1);
degB=size(B,2); // compute the numbers of inputs
[Phim, Phip,h]=FundMatrix(E,A); // laurent expansion
//
if h<2 then
    warning('This method of controlability based in Laurent expansion is only recomended for system with Nilpotence index>=2')
//    warning(msprintf(gettext("%s: Nilpotence index is: %d expected.\n"),"dcontr",2));
// 
 
end

n=1;
for k=h:-1:1
    if degB==1 then
    Ctra(:,n)=clean(Phim(:,:,k)*B);
        
    else
         Ctra(:,:,n)=clean(Phim(:,:,k)*B);
    end
        n=n+1;  
end


for n= 1:Aux
    if degB==1 then
    Ctrb(:,n)=clean(Phip(:,:,n)*B);
else
    Ctrb(:,:,n)=clean(Phip(:,:,n)*B);
    end
    
end

//Controlabilty Matrix
if  degB==1 then
    Cntrd=[Ctra Ctrb]
else
   if h==1 then
       Cntrd=[Ctra Msum(Ctrb)];
    else
    Cntrd=[Msum(Ctra) Msum(Ctrb)];
    end
end

nCa=rank(Cntrd);
if nCa==size(E,1) then
     nC=list("System is C-Controllable (rank)", nCa)
else
       nC=list("System is not C-Controllable (rank)", nCa)
end

C_mat=list("C-Controllability matrix",Cntrd);
// R controlability Matrix
if degB==1 then

Rctrd=Ctrb(:,1:Aux);
else
    
Rctrd=Msum(Ctrb)
end

nRa=rank(Rctrd);
nRb=rank(Phip(:,:,1))
if nRa==nRb then
    nR=list("System is R-Controllable (rank)", nRa)
else
   list("System is R-Controllable (rank)", nRa)
end

R_mat=list('R-controllability matrix (Sum-Phi(+))',Rctrd,'Laurent coefficient Phi0 matrix',Phip(:,:,1));  // R-controlability matrix
// Imp Controlability

if degB==1 then
Ictrb=Ctra(:,1:h-1);
else 
    if h>2 then
  Ictrb=Ctra(:,:,1:h-1);
elseif h==2
    Ictrb=Ctra(:,:,2);
else 
    disp('The system is not Impulse Controlable ')  
    Ictrb=Ctra(:,1:h-1)
    end
  
end



nIa=rank(Ictrb);
if h>=2 then

nIb=rank(Phim(:,:,2));

if nIa==nIb then
 nI=  list("System is I-Controllable (rank)", nIa)
else
    nI=list("System is I-Controllable (rank)", nIa)
end

I_mat=list('I-Controllability matrix (Sum-Phi(-) laurent Coefficients)',Ictrb,'Phi(-2) Laurent Coefficient',Phip(:,:,2))
else
     messagebox(['I-controlabilidad cannot be estimated because the Nilpotency index of N is less than 2' 'Try with other method'],'warning', 'warning')
I_mat=[];
nI=[];
end

//--------------------------------------------------------------------------------------------------------------------------------------------------------
 case 2 then
 
 // This  function verifique the controlability of the system if the nex condition is true

// The slow subsytem  is C controlable if rank [QA1  QB1]= n1--->rank([sI-A1 B1])
// The fast subsystem is C controlable if rank [N B2]= n2
// the system (E,A,B,C,D) is controlable if  rank both slow and fast subsytem are C controlable
 
 
 // kronecker Canonical Form
    [P, Q, n]=pencan(E,A)
   Ae=clean(Q*A*P)
   Be=clean(Q*B)
   Ce=clean(C*P)
    Aux=size(Ee,1); //numbers of rows of Ee Matrix

///....N matrix and Nilpotence Index (h)................

N=Ee(n+1:Aux,n+1:Aux);

  h=1;
Ni=N;
while norm(Ni)>1e-8
    Ni=Ni*N
    h=h+1
     end

// A1 matrix
A1=Ae(1:n,1:n); 

// B1 and B2 Matrix

 B1=Be(1:n,:);
 B2=Be(n+1:size(B,1),:);
 
 
 // Verifiying the controlability theorem
 Cslow=[eye(A1)-A1 B1];
 r1= rank(Cslow);
 Cfast=[N, B2];
 r2=rank(Cfast);
 
 if r1== size(A1,1) & r2==size(N,1) then
    
        
nC=  list("System is C-Controllable", "Slow system rank",r1,"Fast system rank",r2)
 else 
      nC=  list("System is not C-Controllable", "Slow system rank",r1,"Fast system rank",r2)
   
 end
 
 C_mat=list('C-slow subsystem controllability matrix',Cslow,'C-fast subsytem controllability matrix',Cfast)
 
 
 // Rcontrolability
 if rank(Cslow)==size(E,1) then
   nR=list("System is R-Controllable (slow sub-sytem rank)", rank(Cslow)) 
else
    nR=list("System is not R-Controllable (slow sub-sytem rank)",rank(Cslow)) 
 end
 R_mat=list ("R-Controllability matrix",Cslow);
 //I-Controlability
 nI=[]
I_mat=[]

else break;
    end
  endfunction