function [nC,Co_mat,nR,Ro_mat,nI,Io_mat]=dobsv(E,A,C)
    // This function determine de observability if a descriptor system
    
    //1. Cobservability
    //(a) The slow subsystem  is C-observable if and only if
   // $rank\begin{bmatrix}sE-A\\C \end{bmatrix}=n,\,\,\,\forall s\in\mathbb{C},\,\, s\, finite$
   Cslow=[E-A;C]
   nCs=rank(Cslow)
   // //(b) The fast subsystem  is C-observable if and only if
    //$rank\begin{bmatrix}E\\ C \end{bmatrix}=n$
    Cfast=[E;C];
    nCf=rank(Cfast);
    
    Co_mat=list('Slow subsystem',Cslow,'Fast Subsystem',Cfast)
        
    
    
    //(c) The Descriptor system is C-Observable if and only if  the slow subsystem is C-Controlable and the fast subsytem is C-Observable
    if  nCs==nCf & nCs==size(E,1) then
            nC=nCs
        else
            nC=list('System is not C-Controlablye, Slow and Fast Subsytem Ranl',[nCs;nCf])
            
        end



// R observability
Ro_mat=Cslow;
if nCs==size(E,1) then
    nR=list ('System is R-observable',nCs)
else
        nR=list ('System is not R-observable',nCs)
end


// I Observability
//pause

Io_mat=[E A; zeros(E) E; zeros(C) C]
if rank(Io_mat)==(size(E,1)+rank(E)) then
    nI=list ('System is I-observable',rank(Io_mat))
else
        nI=list ('System is not I-observable',rank(Io_mat))
end

endfunction