function [N,G1,L,H2,Bo1]=gosbank(E,A,Bi,Ci,R,alpha,flag)
// sintaxis
//[N,G1,L,H2,Bo1]=gosbank(E,A,Bi,Ci,R,alpha,flag)
//[N,G1,L,H2,Bo1]=gosbank(E,A,Bi,Ci,R,alpha)  Automatic for sensor faults
//[N,G1,L,H2,Bo1]=gosbank(E,A,Bi,Ci,R)  Automatic for sensor faults
//                                         and alpha =5
// This function genera a bank of observers in esqueme DOS
// This compute the observer gains for 
// dz/dt= Nz(t) + G1u(t) + L(yo(t))
// xe(t)= z(t) +H2(yo(t))
//where yo(t) results from QR r.s.e transformation
// yo(t)=[-B1u(t); y(t)];
//flag='a' ; actuator fault
//flag='s' Sensor faults
//alpha put the observer in the stability LMI zone
//E,A,B,C, R are the matrices of the descriptor system


[outputs, inputs ]=argn()

if inputs==5
    alpha=5;
    flag='s';
elseif inputs==6
    flag=='s';
end

if flag=='s'
    no=size(Ci,1); // no=number of observers for IFD
    
elseif flag=='a'
    no=size(Bi,2); //no=number de observers for AFD
end    
    
////    
 j=1;
 h=1;
 N=list();G1=list();L=list();H2=list();Bo1=list();
for j=1:no
    
//// this part select the correct matrices for the GOS structure
//For sensor faults
if flag=='s'
clear C;
    for k=1:no
        
        if k~=j 
    C(k,:)=Ci(k,:);
        end
  
      
    end
    if size(C,1)~=1
     C = C(find(sum(C',1)~=0),:) //// delete rows of zeros
    end
     B=Bi;
// For actuator faults    
elseif flag=='a'
//    pause
clear B;
    for k=1:no
        
        if k~=j 
    B(:,k)=Bi(:,k);
        end
  
      
    end
    if size(B,2)~=1
        B=B';
        
    B= B(find(sum(B',1)~=0),:)';//B(find(:,sum(B')>0)) //// delete rows of zeros
    end
    C=Ci;
end    
//pause
//// This part compute the gains of the observer

[Na,G1a,La,H2a,Bo1a]=puiobsv(E,A,B,C,R,alpha);
N(j)=Na;
G1(j)=G1a;
L(j)=La;
H2(j)=H2a;
Bo1(j)=Bo1a;
j=j+1;

end
endfunction
