function [N,G1,L,H2,B1i]=lpvpuiobsv(E,A,B,C,R,alpha)
//[N,G1,L,H2,Bo1]
//sintaxis
// [N,G1,L,H2,Bo1]=Hamobsv(E,A,B,C,R,alpha)
//// Compte the gains of the observer
// E,A,B,C and R are the matrices od the descriptor system
// N, G1 L, H2 are the gains of the observer
// This compute the observer gains for 
// dz/dt= Nz(t) + G1u(t) + L(yo(t))
// xe(t)= z(t) +H2(yo(t))
//where yo(t) results from QR r.s.e transformation
// yo(t)=[-B1u(t); y(t)];
//alpha put the observer in the stability LMI zone
//E,A,B,C, R are the matrices of the descriptor system

////// sizes
// output variables initialization
for j=1:size(A,3)

[nC,Co_mat,nR,Ro_mat,nI,Io_mat]=dobsv(E,A(:,:,j),C); //// Observability
if nI(2)~=size(E,1)+rank(E)
    
    error('The system is not I-Observable');
    return
end
end

H1=list(); H2=list();
N=list(); L=list(); G1=list();
K=list();B1i=list();
//

n=size(E,1);
m=size(C,1)
r=rank(E);
p=size(B,2);
q=size(R,2);


//
for j=1:size(A,3)
    [Eo, Ao, Ao1, Bo, Bo1, Co, Ro,Ro0]=qrrse(E,A(:,:,j),B(:,:,j),C,R(:,:,j));
    /// observability condition
     nIm=[Ao' Eo' Co'];
 nIma=[nIm;Eo'zeros(size(Eo,2),size(nIm,2)-size(Eo,1))]; 
 if rank(nIma)~=size(E,1)+rank(Eo)
     if rank([Eo-Ao;Co])~=size(E,1)
     error('The sistem is not I-observable')
     return
 end

 end
//     disp(rank(nIma))
    a=size(Ao,1);
//Eei(:,:,j)=Ee;
 Aoi(:,:,j)=Ao; Ao1i(:,:,j)=Ao1; Boi(:,:,j)=Bo; B1i(j)=Bo1;
  Coi(:,:,j)=Co; Roi(:,:,j)=Ro;
  // Eq. 34 
  //H12(:,:,j)=[eye(n,n) zeros(n,q)]**pinv([Eo  Roi(:,:,j); Coi(:,:,j) zeros(size(Coi(:,:,j),1),size(Roi(:,:,j),2))]);
// pause

   H12=[eye(n,n) zeros(n,q)]*pinv([Eo  Roi(:,:,j); Coi(:,:,j) zeros(size(Coi(:,:,j),1),size(Roi(:,:,j),2))]);
   H1(j)=clean(H12(:,1:a));
  H2(j)=clean(H12(:,a+1:size(H12,2)));
  
 end
// pause
 
[X,W]=lpvhamdi09lmi(H1,Aoi,Coi,alpha )

for j=1:size(A,3)
    N;L;G1;K;
    K(j)=inv(X)*W(j);
//pause
//bserver parameters Eq (31-34)
N(j)=clean(H1(j)*Aoi(:,:,j)+K(j)*Coi(:,:,j));
L(j)=clean(N(j)*H2(j)-K(j));
G1(j)=clean(H1(j)*B1i(j));
//pause
end

endfunction
