function [musa]=lpvweig4(Theta,vert)
   // this function genera the weigting functions for according with the parameter varying
   //theta the vector of measured parameters:
   //      theta=[theta1   theta2]
   //ver: the minimum and maximus values of thetas 
   // for example ver1=[ -0.1  0.1] ver2=[-0.05 0.05]
  //  ver=[ver1; ver2]
 // is based in 
 
//﻿M., H., Rodrigues, M., Mechmeche, C., Theilliol, D., Braiek, N. B., & Tunisie, E. P. D. (2009). State Estimation for Polytopic LPV Descriptor Systems : Application to Fault Diagnosis. Convergence (pp. 438-443).
n=size(Theta,1);
m=size(Theta,2);

//$\mu_{1}(\theta(t))\frac{\theta_{1}-\underline{\theta_{1}}}{\theta_{1}-\underline{\theta}_{1}}\frac{\theta_{2}-\underline{\theta}_{2}}{\theta_{2}-\underline{\theta}_{2}}$

//$\mu_{2}(\theta(t))=\frac{\theta_{1}-\underline{\theta}_{1}}{\theta_{1}-\underline{\theta}_{1}}\frac{\overline{\theta}_{2}-\underline{\theta}_{2}}{\theta_{2}-\underline{\theta}_{2}}$
//$\mu_{3}(\theta(t))=\frac{\overline{\theta}_{1}-\theta_{1}}{\theta_{1}-\underline{\theta}_{1}}\frac{\theta_{2}-\underline{\theta}_{2}}{\theta_{2}-\underline{\theta}_{2}}$
//$\mu_{4}(\theta(t))=\frac{\overline{\theta}_{1}-\theta_{1}}{\theta_{1}-\underline{\theta}_{1}}\frac{\overline{\theta}_{2}-\underline{\theta}_{2}}{\theta_{2}-\underline{\theta}_{2}}$
if n<=2 & m<=2
    a=((vert(1,2)-vert(1,1))*(vert(2,2)-vert(2,1)));
        mu1=((Theta(1)-vert(1,1))*(Theta(2)-vert(2,1)))/a;
        mu2=((Theta(1)-vert(1,1))*(vert(2,2)-Theta(2)))/a;
        mu3=((vert(1,2)-Theta(1))*(Theta(2)-vert(2,1)))/a;
        mu4=((vert(1,2)-Theta(1))*(vert(2,1)-Theta(2)))/a;
        mus=[mu1 mu2 mu3 mu4 ];
        musa=[mus sum(mus)];
        elseif n==2 & m>2

for k=1:m
    a=((vert(1,2)-vert(1,1))*(vert(2,2)-vert(2,1)));
        mu1=((Theta(1,k)-vert(1,1))*(Theta(2,k)-vert(2,1)))/a;
        mu2=((Theta(1,k)-vert(1,1))*(vert(2,2)-Theta(2,k)))/a;
        mu3=((vert(1,2)-Theta(1,k))*(Theta(2,k)-vert(2,1)))/a;
        mu4=((vert(1,2)-Theta(1,k))*(vert(2,1)-Theta(2,k)))/a;
        mus=[mu1 mu2 mu3 mu4 ];
       
        musa(k,:)=[mus sum(mus)];
    
    
end
     elseif  n>2 & m==2
        
for k=1:n
    a=((vert(1,2)-vert(1,1))*(vert(2,2)-vert(2,1)));
        mu1=((Theta(k,1)-vert(1,1))*(Theta(k,2)-vert(2,1)))/a;
        mu2=((Theta(k,1)-vert(1,1))*(vert(2,2)-Theta(k,2)))/a;
        mu3=((vert(1,2)-Theta(k,1))*(Theta(k,2)-vert(2,1)))/a;
        mu4=((vert(1,2)-Theta(k,1))*(vert(2,1)-Theta(k,2)))/a;
        mus=[mu1 mu2 mu3 mu4 ];
       
        musa(k,:)=[mus sum(mus)];
    
    
end  

end


endfunction
