function [N,G,L,Ti,H2,Phi]=piuiobsv(E,A,B,C,R,alpha)
// sintaxis
// [N,G,L,Ti,H2,Phi]=dobsvpuio(E,A,B,C,R,alpha)
//
// This function compute the gains of the proportional-integral unkwon input observer
// of descriptor systems
//      dz/dt= Nz(t) + Gu(t) + Ly(t)+Tide(t)
//         xe= z(t) + H2y(t)
//     dde/dt= Phi (y(t)-ye(t))  
// xe = stimated states
//y(t)=output
//ye(t)=stimated output
// alpha = put the observer in the stable zone of the LMI
//E,A,B,C,R are the matrices of the descriptor system
//N,G,L,Ti,H2,Phi are the gain matrices of the observer
  n=size(E,1);
  m=size(C,1);
  
//// cheking the feasibility of the observer
 [nC,Co_mat,nR,Ro_mat,nI,nI_mat]=dobsv(E,A,C);
if rank(C)==m
    if nR(2)==n
        if nI(2)==6
        end
    end

    
EC=pinv([E;C]);
H1=EC(:,1:n);
H2=EC(:,n+1:size(EC,2));

    ////eq 18-21
    Ti=H1*R;
    G=H1*B;
    ////Eq 32+
    aux=[H1*A  Ti];
    l=size(aux,2);
    As=clean([aux; zeros(1,l)]);
Cs=[C zeros(size(C,1),1)];

//
//
//  yalmip ('clear')
//Q=sdpvar(l,l,'symmetric');
//Wi=sdpvar(l,size(C,1),'full');
//
//// ////eq. 29
////  
//F=[Q>0];
//F=[F, As'*Q+Q*As-Cs'*Wi'-Wi*Cs+2*alpha*Q<0  ];
//
//ops = sdpsettings('solver','lmilab','verbose',0);
//solvesdp(F,-trace(Q),ops);
//Q=double(Q);
//W=double(Wi);

[Q,W]=hamdi11lmi(As,Cs,alpha ,l);

Kis=inv(Q)*W;
// load Kis.mat;
K=Kis(1:n,:);
Phi=Kis(n+1,:);
N=H1*A-K*C;
L=K+N*H2;
else
    error ('The system does not meet the conditions of R or I Observability ');
end
endfunction