function [N,G1,L,H2,Bo1]=puiobsv(E,A,B,C,R,alpha)
//sintaxis
// [N,G1,L,H2,Bo1]=Hamobsv(E,A,B,C,R,alpha)
//// Compte the gains of the observer
// E,A,B,C and R are the matrices od the descriptor system
// N, G1 L, H2 are the gains of the observer
// This compute the observer gains for 
// dz/dt= Nz(t) + G1u(t) + L(yo(t))
// xe(t)= z(t) +H2(yo(t))
//where yo(t) results from QR r.s.e transformation
// yo(t)=[-B1u(t); y(t)];
//alpha put the observer in the stability LMI zone
//E,A,B,C, R are the matrices of the descriptor system

[nC,Co_mat,nR,Ro_mat,nI,Io_mat]=dobsv(E,A,C); //// Observability
if nI(2)~=size(E,1)+rank(E)
    
    error('The system is not I-Observable');
    return
end
 [Eo, Ao, Ao1, Bo, Bo1, Co, Ro,Ro0]=qrrse(E,A,B,C,R);
 nIm=[Ao' Eo' Co'];
 nIma=[nIm;Eo'zeros(size(Eo,2),size(nIm,2)-size(Eo,1))]; 
 if rank(nIma)~=size(E,1)+rank(Eo)
     if rank([Eo-Ao;Co])~=size(E,1)
     error('The sistem is not I-observable')
     return
     end
 end
//Eei=Ee;


//// sizes
n=size(E,1);
m=size(C,1)
r=rank(E);
p=size(B,2);
q=size(R,2);
a=size(Ao,1);
////  Considering for the first UIO
//   Boi=[1 1; 1 0.5];
//   Ro=[1;1];
//   Foi=[1;0.5];

  // Eq. 34 
  H12=[eye(n,n) zeros(n,q)]*pinv([Eo  Ro; Co zeros(size(Co,1),size(Ro,2))]);
  H1=H12(:,1:a);
 H2=clean(H12(:,a+1:size(H12,2)));
//
// yalmip ('clear');
//X=sdpvar(n,n,'symmetric');
//W=sdpvar(n,size(Co,1),'full');

////eq. 29
//pause
 [X,W]=hamdi09lmi(H1,Ao,Co,alpha )
//F=[X>0];
//F=[F,((H1*Ao)'*X+X*(H1*Ao)+W*Co+Co'*W'+2*alpha*X)<0];
//ops = sdpsettings('solver','lmilab','verbose',0);
//solvesdp(F,-trace(X),ops);
//X=double(X);
//W=double(W);


 K=inv(X)*W;


//// Observer parameters Eq (31-34)
N=clean(H1*Ao+K*Co);
L=clean(N*H2-K);
G1=clean(H1*Bo1);
endfunction
