function [Ee, Ae, Ae1, Be, Be1, Ce,Fe,Fe1,De]=qrrse(E,A,B,C,F,G)
    // QR Restricted system equivalence
    // when $PE=\begin{bmatrix} E \cr 0\end{bmatrix}$ 
    //  $PA=\begin{bmatrix}  Ae \cr Ae_1\end{bmatrix}$
    //$PB=\begin{bmatrix} Be \cr Be_1 \end{bmatrix}$
    //$PA=\begin{bmatrix} Ae \cr Ae_1 \end{bmatrix}$
    //$Ce=\begin{bmatrix}Ae \cr\cr C \end{bmatrix}$
    // with $P$ is from $QR$ descomposition
    // rcon check the next condition
    // $rank\begin{bmatrix} E \ \ A \cr 0 \ \ E \cr 0 \ \ C\end{bmatrix}=n +rankE$
    //or equivalent $rank\begin{bmatrix} E \cr C \end{bmatrix}=n$
    
    
[lhs,rhs]=argn(0) 

//
//rhs = nargin;
//lhs=nargout;
    [P, R]=qr(E); // QR factorization  

    PE=P*E;
    PA=P*A;
    PB=P*B;
    n=size(E,1);
    r=rank(E);
    k=size(B,2);
    p=size(C,1);
    
    Ee=PE(1:r,:);
    Ae=PA(1:r,:);
    Ae1=PA(r+1:size(PA,1),:);
    Be=PB(1:r,:);
    Be1=PB(r+1:size(PB,1),:);
    Ce=[Ae1;C];
       
   
 if  rhs==5 & lhs>6 
   
    
   PF=P*F;
     
   Fe=PF(1:r,:);
   Fe1=PF(r+1:size(PF,1),:);
    
elseif rhs >5 &  lhs>7 
    //q=size(G,2);
    
   PF=P*F;
     
   Fe=PF(1:r,:);
   Fe1=PF(r+1:size(PF,1),:);
   De=[Fe1;G];
   rcon=rank([Ee;Ce])==size(E,1) ;
else
     rank([Ee Ae; zeros(Ee) Ee; zeros(Ce) Ce])==size(E,1)+rank(Ee) ;
   
   
    rcon=rank([Ee;Ce])==size(E,1) ;
end

endfunction

//Any real square matrix A may be decomposed as 
   //   $QR$
//   
//   Rectangular matrix
//
//More generally, we can factor a complex $m×n$ matrix $A$, with $m ≥ n$, as the product of an m×m unitary matrix $Q$ and an $m×n$ upper triangular matrix $R$. As the bottom $(m−n)$ rows of an $m×n$ upper triangular matrix consist entirely of zeroes, it is often useful to partition $R$, or both $R$ and $Q$.:
//
//   $ A = QR = Q \begin{bmatrix} R_1 \\ 0 \end{bmatrix} $
//$=\begin{bmatrix} Q_1, Q_2 \end{bmatrix} \begin{bmatrix} R_1 \\ 0 \end{bmatrix} = Q_1 R_1, $
//where $R_1$ is an $n×n$ upper triangular matrix, $Q_1$ is $ m×n$, $Q_2$ is $m×(m−n)$E, and $Q_1$ and $Q_2$ both have orthogonal columns.


     
